#ifndef __VEC_CL
#define __VEC_CL
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#define max_int(y,z) ((y)<(z))?(y):(z)

template<class T> class vector
{
  protected:
    T **t;
    T *tt;
    int dim;
    int max_el;
    int step;
    int expand(int i)
    {
				  T** q;
                  q=new T*[(i+this->step)];
                  if (q==NULL)
                        {
                          i=0;
						  return -1;
                        }
                  else
                        {
                  		  memset((char*)q,0,(i+step)*sizeof(T*));
                          max_el=i;
                          for (int y=0;y<dim;y++) q[y]=this->t[y];
                          dim=i+step;
                          delete[] this->t;
                          this->t=q;
                        }
				   return 0;
    }
  public:
    inline ~vector () 
	{
		destroy();
		if(tt) delete[]tt;
	}
	void destroy()
	{
		if (t)
		{
			for(int i=0;i<dim;i++)if (t[i]) delete t[i];
			delete []t;
			t=NULL;
			dim=0;
			max_el=-1;
		}
	}
    vector (int d=20,int st=10,int dist=1);
    int get_dim() {return dim;}
    virtual int get_n_el() {return max_el+1;}
	operator T*() 
		{
			if(tt) delete[]tt;
			tt=new T[max_el+1];
			for (int i=0;i<max_el;i++)
			{
			 if (t[i]==NULL) 
				 memset((char*)(tt+i),0,sizeof(T));
			 else
				 memcpy (tt+i,t[i],sizeof(T)); 
			}
			destroy();
			return tt;
		}
    virtual T& operator[](int i)
        {
		 if (i<0) i=0;
         if (t==NULL)
			{
				t=new T*[1];
				t[0]=new T;
				dim=1;
				max_el=0;
				return *t[0];
			}
            else
             if (i>=dim) //espande il vettore
               {expand(i); }
         if (i>max_el) max_el = i;
		 if (t[i]==NULL) 
		 {
			 t[i]=new T;
			 memset((char*)t[i],0,sizeof(T));
	     }
         return *(t[i]);
        }
};

template<class T> vector<T>:: vector (int d,int st,int dist)
     {
      t=new T*[d];
      memset((char*)t,0,d*sizeof(T*));
      dim=d;
      if (st>0) step=st; 
       else step=1;
      max_el=-1;
	  tt=NULL;
     }

#endif
